package org.equinoxosgi.simona.internal.big;

import org.equinoxosgi.simona.big.IBig;
import org.equinoxosgi.simona.other.IOther;

public class Big extends Object implements IBig {
  public static Big INSTANCE;

  private IOther other;
  private Thread thread;
  private IBigCallback callback;

  public Big(IOther other) {
    super();
    if (other == null)
      throw new IllegalArgumentException("other must not be null");
    System.out.println("Big::Big(IOther)");
    this.other = other;
  }

  private Runnable createRunnable() {
    return new Runnable() {
      @Override
      public void run() {
        Big.this.initialize();
      }
    };
  }

  public void foo() {
    System.out.println("Big::foo()");
  }

  private void initialize() {
    System.out.println("Big::initialize()");
    try {
      Thread.sleep(5000);
      other.bar();
      System.out.println("Big::initialize() - Complete!");
      callback.initialized();
    } catch (InterruptedException e) {
      System.out.println("Big::initialize() - Interrupted!");
    }
  }

  public void start(IBigCallback callback) {
    if (callback == null)
      throw new IllegalArgumentException("callback must not be null");
    synchronized (this) {
      if (thread != null) return;
      System.out.println("Big::start(IBigCallback)");
      this.callback = callback;
      startThread();
    }
  }

  private void startThread() {
    System.out.println("Big::startThread()");
    Runnable runnable = createRunnable();
    thread = new Thread(runnable, "Big-initializer");
    thread.start();
  }

  public void stop() throws InterruptedException {
    synchronized (this) {
      if (thread == null)
        return;
      System.out.println("Big::stop()");
      stopThread();
      callback = null;
    }
  }

  private void stopThread() throws InterruptedException {
    System.out.println("Big::stopThread()");
    thread.interrupt();
    thread.join();
    thread = null;
  }
}
