package org.equinoxosgi.simona.internal.big.bundle;

import org.equinoxosgi.simona.internal.big.Big;
import org.equinoxosgi.simona.internal.big.IBigCallback;
import org.equinoxosgi.simona.other.IOther;
import org.osgi.service.component.ComponentContext;

public class BigComponent extends Object {
  private static final String SMALL_COMPONENT = "small";
  private ComponentContext context;

  public BigComponent() {
    super();
    System.out.println("BigComponent::BigComponent()");
  }

  public void activate(ComponentContext context) {
    System.out.println("BigComponent::activate()");
    this.context = context;
    startBig();
  }

  private IBigCallback createBigCallback() {
    return new IBigCallback() {
      @Override
      public void initialized() {
        BigComponent.this.enableSmallComponent();
      }
    };
  }

  public void deactivate(ComponentContext context) {
    System.out.println("BigComponent::deactivate()");
    disableSmallComponent();
    stopBig();
    context = null;
  }

  private void disableSmallComponent() {
    System.out.println("BigComponent::disableSmallComponent()");
    context.disableComponent(BigComponent.SMALL_COMPONENT);
  }

  private void enableSmallComponent() {
    System.out.println("BigComponent::enableSmallComponent()");
    context.enableComponent(BigComponent.SMALL_COMPONENT);
  }

  private void startBig() {
    System.out.println("BigComponent::startBig()");
    String name = IOther.class.getName();
    IOther other = (IOther) context.locateService(name);
    Big.INSTANCE = new Big(other);
    Big.INSTANCE.start(createBigCallback());
  }

  private void stopBig() {
    System.out.println("BigComponent::stopBig()");
    try {
      Big.INSTANCE.stop();
    } catch (InterruptedException e) {
      e.printStackTrace();
    } finally {
      Big.INSTANCE = null;
    }
  }
}
